// ---------------------------------------------------------- //
// fast_query.h: header file for the fast-query dynamic       //
//               connectivity algorithm                       //
// version 1.0 Nov 2 1995, David Alberts                      //
// ---------------------------------------------------------- //

#include<LEDA/graph.h>

typedef GRAPH<int,int> fq_graph;

void fq_init(fq_graph &G);
// initializes the data structure

int  fq_query(node v, node w);
// returns true iff v and w are connected in G
// precondition: v, w are nodes of G

edge fq_insert(node v, node w);
// inserts an edge between v and w in G
// precondition: v, w are nodes of G and they are not already
//               connected by a single edge

void fq_delete(edge e);
// deletes the edge e from G
// precondition: e is an edge of G

int fq_bad();
// return #bad updates since initialization
