// ---------------------------------------------------------- //
// fast_update.h: header file for the fast-update connectivity//
//             algorithm                                      //
//                                                            //        
// version 1.0 Nov 2 1995, David Alberts                      //
// ---------------------------------------------------------- //

#include<LEDA/graph.h>

void fu_init(graph &G);
// initializes the data structure

int  fu_query(node v, node w);
// returns true iff v and w are connected in G
// precondition: v, w are nodes of G

edge fu_insert(node v, node w);
// inserts an edge between v and w in G
// precondition: v, w are nodes of G and they are not already
//               connected by a single edge

void fu_delete(edge e);
// deletes the edge e from G
// precondition: e is an edge of G
