#!/usr/local/ts/bin/perl
# replace this with your perl path

# builds inputs used in experiments by Iyer, Karger, Rahul, and Thorup

##############################
# random inputs
##############################

# big expander graph serves as candidate edge set 
$cmd = "../bin/gen_random.pl 20000 1000000 > rand20000_1000000.gr";
print "$cmd\n";
system "$cmd";

# m=n/2
$cmd = "../bin/gen_ops rand20000_1000000.gr 10000 rand_20000_10000_2000000_2000000_2000000 2000000 2000000 2000000";
print "$cmd\n";
system "$cmd";

# m=2n
$cmd = "../bin/gen_ops rand20000_1000000.gr 40000 rand_20000_40000_2000000_2000000_2000000 2000000 2000000 2000000";
print "$cmd\n";
system "$cmd";

##############################
# semirandom inputs
##############################

# n=2000 m=2n

#candidate set of 2n edges
$cmd = "../bin/gen_random.pl 2000 4000 > rand2000_4000.gr";
print "$cmd\n";
system "$cmd";

#semirandom graph
$cmd = "../bin/gen_ops rand2000_4000.gr 4000 srand_2000_4000_2000000_2000000_2000000 2000000 2000000 2000000";
print "$cmd\n";
system "$cmd";

#random graph of same size for comparison
# expander candidate set 
$cmd = "../bin/gen_random.pl 2000 100000 > rand2000_100000.gr";
print "$cmd\n";
system "$cmd";

#random graph
$cmd = "../bin/gen_ops rand2000_100000.gr 4000 rand_2000_4000_2000000_2000000_2000000 2000000 2000000 2000000";
print "$cmd\n";
system "$cmd";

##############################
# two-level inputs
##############################

@num_cliques = (4,10,20,40,50,100,200,500);
$n = 2000;
foreach $k (@num_cliques) {
    $c = $n/$k;
    $upd = 100000;
    $cmd = "../bin/gen_two-level $k $c $upd $upd $upd c_$k\_$c\_$upd\_$upd\_$upd";
    print "$cmd\n";
    system "$cmd";
}

##############################
# 2 cliques connected by edge
##############################

$c = 1000;
$upd = 10000;
$cmd = "../bin/gen_2cliques1edge $c $upd $upd $upd 2cliques1edge_$c\_$upd\_$upd\_$upd";
print "$cmd\n";
system "$cmd";

##############################
# line: worst case for HDT
##############################

for( $k=9; $k<=16; $k++ ) {
    $cmd = "../bin/gen_line_bs.pl $k line_k$k";
    print "$cmd\n";
    system "$cmd";
}
