#!/usr/local/ts/bin/perl
# put your perl path here

# run algorithms on graph, output to gnuplot format

( @ARGV == 1 ) || 
    die "usage: quick_run.pl name\n\truns algorithms on name.{gr,upd}\n";

$bin = "../bin";

$gr = $ARGV[0];

# set update sequence
$upd = "1000 2500 5000 7500 10000 25000 50000 75000 100000 250000 500000 750000 1000000 1250000 1500000 1750000 2000000";

# set algorithms and their arguments
@alg = (
	"test_hk_var",
#	"test_hdt",
#	"test_hdt",
#	"test_hdt",
#	"test_hdt",
#	"test_hk",
	);

@arg = (
	 "",
#	 "256 64",
#	 "0 0",
#	 "0 2000",
#	 "256 0",
#	 "",
	 );

for( $i=0; $i<@alg; $i++ ) {
    $cmd = "$bin/$alg[$i] $gr $arg[$i] $upd";
    print "$cmd\n";
    $res = `$cmd`;

    # turn to column 
    open( OUT, ">a$i.out" ) || die "couldn't open a$i.out\n";
    $a = $alg[$i];
    $a =~ s/test_//; 
    print OUT "$a $arg[$i]\n";
    @a = split( /\s+/, $res );
    for( $j=3; $j<@a; $j+= 3 ) {
	print OUT "$a[$j+2]\n";
	
    }
    close( OUT);
}

open( OUT, ">first.out" ) || die "couldn't open first.out\n";
print OUT "#\n";
@a = split( /\s/, $upd );
foreach $p (@a) { print OUT "$p\n" }
close(OUT);

$cmd = "paste first.out";
for( $i=0; $i<@alg; $i++ ) {
    $cmd .= " a$i.out";
}
$cmd .= " > $gr.out";

print "$cmd\n";
system "$cmd";


