#!/usr/local/ts/bin/perl -w
# Replace with your perl path
#
#// ---------------------------------------------------- //
#// gen_random.pl: Generate a sparse random graph	 //
#//                                                      //
#// usage: gen_random.pl n m [seed]			 //
#//             n = #nodes                    		 //
#//             m = #edges                            	 //
#//							 //
#// Prints to stdout in LEDA format			 //
#// ---------------------------------------------------- //

if( @ARGV < 2 || @ARGV > 3 ) {
    die "usage: gen_random.pl n m [seed]\n".
	"\tn = #nodes\n".
	"\tm = #edges\n\n".
        "Prints to stdout in LEDA format\n";
}

$seed = 1;

$nnodes = shift;
$nedges = shift;

if( @ARGV == 1 ) {
    $seed = shift;
}

srand $seed;

$edgemap[0][0] = 0;

print "LEDA.GRAPH\nvoid\nvoid\n$nnodes\n";
for($i = 0; $i < $nnodes; $i++) {
    print "|\{\}|\n";
}

print "$nedges\n";

for($i = 0; $i < $nedges; $i++) {
    GetOneEdge($nnodes);
    print "$u $v 0 |\{\}|\n";
}

sub GetOneEdge($nnodes) {
    $flag = 1;
    while ($flag) {
	$u = int(rand $nnodes)+1;
	$v = $u;
	while ($v == $u) {
	    $v = int(rand $nnodes)+1;
	}
	if (!defined($edgemap[$u][$v])) {
	    $edgemap[$u][$v] = $edgemap[$v][$u] = 1;
	    $flag = 0;
	}
    }
}
	

