#!/usr/local/ts/bin/perl -w
# Replace with your perl path
#
#// ---------------------------------------------------- //
#// makecompl.pl: Generate a complete graph on n nodes.  //
#//                                                      //
#// usage: gen_line_bs.pl k name                  	 //
#//             k=log(n), n=# of nodes in line		 //
#//             name = name of output files (.gr,.upd)	 //
#// ---------------------------------------------------- //

$|=1;

( @ARGV == 1 ) || 
    die "usage: makecompl.pl n\n\tn = number of nodes in complete graph\n";

$n = $ARGV[0];
$out = "comp$n";

open( OUTF, ">$out.gr" ) || 
    die "can't open $out.gr\n";
print OUTF "LEDA.GRAPH\nvoid\nvoid\n$n\n";
for($i = 0; $i < $n; $i++) {
    print OUTF "|\{\}|\n";
}
$m = $n*($n-1)/2;
print OUTF "$m\n";
for($i=1;$i<=$n;$i++) {
    for($j=$i+1;$j<=$n;$j++) {
	print OUTF "$i $j 0 |{}|\n";
    }
}
close(OUTF);
